/* chkd.h
 */

#ifndef _CHKD_H
#define _CHKD_H

/* twidhw.c (thw prefix) */
#define		TB_NONE		0x0
#define		TB_LEFT		0x1
#define		TB_MIDDLE	0x2
#define		TB_RIGHT	0x3

enum thw_keyrow_e {
  TR_ROW1 = 1,
  TR_ROW2 = 2,
  TR_ROW3 = 3,
  TR_ROW4 = 4,
  TR_ALT,
  TR_FN,
  TR_NUM,
  TR_CTRL,
  TR_MOUSE,
  TR_SHIFT,
  TR_LAST
};

struct thw_callback_s {
  void (*keydown)(enum thw_keyrow_e row, int button);
  void (*keyup)(enum thw_keyrow_e row, int button);
  void (*relmove)(int x, int y);
};

extern int	thw_open(char *devpath);
extern void	thw_close();
extern void	thw_update(struct thw_callback_s *callbacks);


/* out_ui.c (odev prefix) */
extern int	odev_open(char *path);
extern void	odev_close();
extern void odev_sendkeydown(unsigned short scancode);
extern void odev_sendkeyup(unsigned short scancode);

/* structs for keymap.c */
extern int	km_getscancode(char *keyname);

struct keymap_s {
  char *		keyname;
  unsigned short	scancode;
};
extern struct keymap_s	keymap[];
extern const int	keycount;

/* decode.c */
extern struct thw_callback_s decode_callback;
extern void decode_init(char *mapfile);
#endif /* _CHKD_H */
